// CustomBrowseFoldersDlg.cpp : implementation file
//

#include "stdafx.h"
#include "CustomBrowseFolders.h"
#include "CustomBrowseFoldersDlg.h"

#include "BrowsePackagesDialog.h"

#include <shlobj.h>					//for Shell API
#include <Shlwapi.h>				//for Shell API


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CCustomBrowseFoldersDlg dialog




CCustomBrowseFoldersDlg::CCustomBrowseFoldersDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCustomBrowseFoldersDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCustomBrowseFoldersDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CCustomBrowseFoldersDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_SHOW_STANDARD_BROWSER, &CCustomBrowseFoldersDlg::OnBnClickedShowStandardBrowser)
	ON_BN_CLICKED(IDC_SHOW_CUSTOM_BROWSER, &CCustomBrowseFoldersDlg::OnBnClickedShowCustomBrowser)
END_MESSAGE_MAP()


// CCustomBrowseFoldersDlg message handlers

BOOL CCustomBrowseFoldersDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CCustomBrowseFoldersDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCustomBrowseFoldersDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCustomBrowseFoldersDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}



void CCustomBrowseFoldersDlg::OnBnClickedShowStandardBrowser()
{
	//standard use of the Shell API to browse for folders
	bool f_selected = false;

	char szDir [MAX_PATH];
	BROWSEINFO bi;         
	LPITEMIDLIST pidl;         
	LPMALLOC pMalloc;
	if (SUCCEEDED (::SHGetMalloc (&pMalloc))) 
	{
		::ZeroMemory (&bi,sizeof(bi));  

		CString custom_msg;
		custom_msg = "Go ahead, select a directory:";

		bi.lpszTitle = custom_msg;
		bi.hwndOwner = this ->GetSafeHwnd ();
		bi.pszDisplayName = 0;            
		bi.pidlRoot = 0;
		bi.ulFlags = BIF_RETURNONLYFSDIRS | BIF_STATUSTEXT;
		bi.lpfn = NULL;			//no customization function
		bi.lParam = NULL;		//no parameters to the customization function

		pidl = ::SHBrowseForFolder(&bi);            
		if (pidl) 
		{
			if (::SHGetPathFromIDList (pidl, szDir)) 
			{
				f_selected = true;
			}
		   
			pMalloc -> Free(pidl); 
			pMalloc -> Release();
		}      
	}

	if (f_selected)
	{
		MessageBox (szDir, "User selected path:");
	}
}

void CCustomBrowseFoldersDlg::OnBnClickedShowCustomBrowser()
{
	//show our customized folder browser dialog
	CBrowsePackagesDialog dlg (this);
	dlg.Show ();
}
